//************************************************************
//  University of Patras 
//      Department of Electrical Engineering & Computer Technology
//       
//      Course: Parallel Programming in AI 
//      Week 03: Simple c++ programs using threads
//
//        ex9.cpp: Printing Hello World
//      Author: Evangelos Dermatas
//      v0.1
/*
*********************************************************************
gcc -v: gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS:     Linux Ubuntu 18.04
CPU:    8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:      g++ ex9.c -o ex9 -pthread
Executing:      ./ex9

Output in my Laptop:

Hello from main 0 Word
Hello from main 1 Word
Hello from main 2 Word
Hello from main 3 Word
Hello from main 4 Word
Hello from main 5 Word
Hello from Goodnight  0 Word
Hello from Goodnight  1 Word
Hello from Goodnight  2 Word
Hello from Goodnight  3 Word
Hello from Goodnight  4 Word
Hello from main 6 Word
Hello from main 7 Word
Hello from main 8 Word
Hello from main 9 Word

*/

// ***************************************
#include <iostream>
#include <thread>

// ***************************************
using namespace std ;

// ***************************************
void f1(string s)
{
for( int i=0 ; i < 5 ; i++ )
	cout<<"Hello from "<< s << "  " << i << " Word" << endl ;

}


// ***************************************
int main()
{
thread th1(f1,"Goodnight") ;
//th1.detach() ;

for( int i = 0 ; i < 10 ; i++ ) {
	cout<<"Hello from main "<< i <<" Word\n" ;
	if ( i==5 && th1.joinable() ) 
		th1.join() ; 
	}

if( th1.joinable())
	th1.join() ;

return 0 ;
}
